#include<Adafruit_NeoPixel.h>
#include <SoftwareSerial.h>

#define PIN 5 //네오픽셀

#define btn1  2  // 버튼1의 아두이노 핀번호 정의  도
#define btn2  6 // 버튼2의 아두이노 핀번호 정의  레
#define btn3  7  // 버튼3의 아두이노 핀번호 정의  미
#define btn4  8   // 버튼4의 아두이노 핀번호 정의  파
#define btn5  9   // 버튼5의 아두이노 핀번호 정의  솔
#define btn6  10   // 버튼6의 아두이노 핀번호 정의  라
#define btn7  11   // 버튼7의 아두이노 핀번호 정의  시
#define btn8  12   // 버튼8의 아두이노 핀번호 정의  높은도
// 3:midi rx , 4:midi reset  아두이노 핀 3번 4번은 이미 사용중

#define btn9 A5   // 버튼9의 아두이노 핀번호 정의, 악기 종류(0~127) 증가 버튼
#define btn10 A4  // 버튼10의 아두이노 핀번호 정의, 악기 종류(0~127) 감소 버튼
#define btn11 A3  // 버튼11의 아두이노 핀번호 정의, 드럼
#define btn12 A2  // 버튼12의 아두이노 핀번호 정의, 지정 악기

#define btn13 A0  //  1옥타브 버튼
#define btn14 A1  // 2옥타브 버튼
#define btn15 1  // 3옥타브 버튼

#define defaultPatch 40 //버튼12의 아두이노 핀번호, 악기 초기화 버튼 설정 악기번호, 바이올린


SoftwareSerial mySerial(2, 3); //SW시리얼핀 정의 D3이 MIDI신호 전송용,  D2는 미사용 

byte note = 0; //The MIDI연주될 note(음계)
byte resetMIDI = 4; // VS1053 Reset용 핀
byte ledPin = 13; //MIDI 트래픽 표시용 LED
 
boolean bs1 = false;  // 버튼1의 현재상태(눌림 or 안눌림)
boolean bs2 = false;  // 이하, 위와 유사
boolean bs3 = false;
boolean bs4 = false;
boolean bs5 = false;
boolean bs6 = false;
boolean bs7 = false;
boolean bs8 = false;

boolean bs9 = false;
boolean bs10 = false;
boolean bs11 = false;
boolean bs12 = false;

boolean bs13 = false;
boolean bs14 = false;
boolean bs15 = false;

boolean br1;  // 버튼1 상태 확인용 입력값 임시저장용
boolean br2;  // 이하, 위와 유사
boolean br3;
boolean br4;
boolean br5;
boolean br6;
boolean br7;
boolean br8;

boolean br9;
boolean br10;
boolean br11;
boolean br12;

boolean br13;
boolean br14;
boolean br15;

int patch = 19; //전원 처음 넣었을 때 연주될 악기 종류 (0~127: 기본 128 가지 선택가능), 오르간

int bn1 = 48; //버튼1의  note(음계)  "도" (정확한 음계 설정은 MIDI관련정보참고)
int bn2 = 50; //버튼2의  note(음계)  "레"
int bn3 = 52; //버튼3의  note(음계)  "미"
int bn4 = 53; //버튼4의  note(음계)  "파"
int bn5 = 55; //버튼5의  note(음계)  "솔"
int bn6 = 57; //버튼6의  note(음계)  "라"
int bn7 = 59; //버튼7의  note(음계)  "시"
int bn8 = 60; //버튼8의  note(음계)  "도~", 이상 1옥타브 음계

int bn11 = 60; //버튼1의  note(음계)  "도" 
int bn12 = 62; //버튼2의  note(음계)  "레"
int bn13 = 64; //버튼3의  note(음계)  "미"
int bn14 = 66; //버튼4의  note(음계)  "파"
int bn15 = 67; //버튼5의  note(음계)  "솔"
int bn16 = 69; //버튼6의  note(음계)  "라"
int bn17 = 71; //버튼7의  note(음계)  "시"
int bn18 = 72; //버튼8의  note(음계)  "도~~", 이상 2옥타브 음계


int bn21 = 72; //버튼1의  note(음계)  "도"  
int bn22 = 74; //버튼2의  note(음계)  "레"
int bn23 = 76; //버튼3의  note(음계)  "미"
int bn24 = 77; //버튼4의  note(음계)  "파"
int bn25 = 79; //버튼5의  note(음계)  "솔"
int bn26 = 81; //버튼6의  note(음계)  "라"
int bn27 = 83; //버튼7의  note(음계)  "시"
int bn28 = 84; //버튼8의  note(음계)  "도~~~", 이상 3옥타브 음계

byte byteData;
 Adafruit_NeoPixel pixels(4, PIN, NEO_GRB + NEO_KHZ800);
// 네오픽셀(4-led개수, PIN- 핀번호, NEO_GRB + NEO_KHZ800 - RGB번호)
 
void setup() {
  pixels.begin(); //네오픽셀 시작, 5번핀에 연결된 4개 led 네오픽셀 연결
  pixels.clear(); //네오픽셀 초기화
  Serial.begin(31250);
  //미디컨트롤을 위한 소프트웨어 시리얼을 준비합니다.
  mySerial.begin(31250);
   //  mySerial2.begin(57600);
   // VS1053를 초기화하고 사용할 준비를 합니다.

  pinMode(resetMIDI, OUTPUT);
  digitalWrite(resetMIDI, LOW);
  delay(100);
  digitalWrite(resetMIDI, HIGH);
  delay(100);
  

  pinMode( btn1, INPUT);    // 버튼1 입력용 핀모드를  입력모드로 전환
 digitalWrite( btn1, HIGH);  /* 내부 PullUp 설정, 스위치의 나머지 한선은 GND에 물리면 됩니다. 버튼 3개 택트 스위치 연결시 VCC, GND 브레드 보드(쉴드)와 반대로 연결, 똑같이 연결할 경우 버튼을 누른 후 소리가 나옴 */

  pinMode( btn2, INPUT);      // 이하, 위와 유사
  digitalWrite( btn2, HIGH);
  pinMode( btn3, INPUT);
  digitalWrite( btn3, HIGH);
  pinMode( btn4, INPUT);
  digitalWrite( btn4, HIGH);
  pinMode( btn5, INPUT);
  digitalWrite( btn5, HIGH); 
  pinMode( btn6, INPUT);
  digitalWrite( btn6, HIGH);
  pinMode( btn7, INPUT);
  digitalWrite( btn7, HIGH);
  pinMode( btn8, INPUT);
  digitalWrite( btn8, HIGH);

  pinMode( btn9, INPUT);
  digitalWrite( btn9, HIGH);
  pinMode( btn10, INPUT);
  digitalWrite( btn10, HIGH);
  pinMode( btn11, INPUT);
  digitalWrite( btn11, HIGH);
  pinMode( btn12, INPUT);
  digitalWrite( btn12, HIGH);

  pinMode( btn13, INPUT);
  digitalWrite( btn13, HIGH);
  pinMode( btn14, INPUT);
  digitalWrite( btn14, HIGH);
  pinMode( btn15, INPUT);
  digitalWrite( btn15, HIGH);

talkMIDI(0xc0, patch, 0);  // 악기 초기 값 설정

}


void loop() {
    
    br1 = digitalRead(btn1); // #define btn1 2 // 버튼1의 아두이노 핀번호 정의  도
    br2 = digitalRead(btn2); // #define btn2 6 // 버튼2의 아두이노 핀번호 정의  레
    br3 = digitalRead(btn3); // #define btn3 7 // 버튼3의 아두이노 핀번호 정의  미
    br4 = digitalRead(btn4); // #define btn4 8 // 버튼4의 아두이노 핀번호 정의  파
    br5 = digitalRead(btn5); // #define btn5 9 // 버튼5의 아두이노 핀번호 정의  솔
    br6 = digitalRead(btn6); // #define btn6 10 // 버튼6의 아두이노 핀번호 정의  라
    br7 = digitalRead(btn7); // #define btn7 11 // 버튼7의 아두이노 핀번호 정의  시
    br8 = digitalRead(btn8); // #define btn8 12 // 버튼8의 아두이노 핀번호정의 높은도
   // 3:midi rx , 4:midi reset  아두이노 핀 3번 4번은 이미 사용중

    br9 = digitalRead(btn9);
    // #define btn9 A5   // 버튼9의 아두이노 핀번호 정의, 악기 종류(0~127) 증가 버튼
    br10 = digitalRead(btn10);
   // #define btn10 A4  // 버튼10의 아두이노 핀번호 정의, 악기 종류(0~127) 감소 버튼
    br11 = digitalRead(btn11);  
   // #define btn11 A3  // 버튼11의 아두이노 핀번호 정의, 드럼
    br12 = digitalRead(btn12);    
   // #define btn12 A2  // 버튼12의 아두이노 핀번호 정의, 지정 악기

    br13 = digitalRead(btn13); // #define btn13 A0// 1옥타브 버튼
    br14 = digitalRead(btn14); // #define btn14 A1// 2옥타브 버튼
    br15 = digitalRead(btn15); // #define btn15 1//  3옥타브 버튼  

if (br13 == HIGH) {//A0 버튼 누르지 않으면 

   pixels.clear(); // 네오픽셀 끄기
   pixels.show(); // 네오픽셀 초기화
   noteOff(0, 0, 0); // 음계 끄기 
   } 

  else { //A0 버튼을 눌렀다면, 1옥타브 버튼

if( !bs1 && !br1 ){ // boolean bs1 = false; // boolean br1;//
 // br1 = digitalRead(btn1); // #define btn1 2 // 버튼1의 아두이노 핀번호 정의 도
     noteOn(0, bn1,100);
 //void noteOn(byte channel, byte note, byte attack_velocity) 
     bs1 = true; // boolean bs1 = false;
         

for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 204, 61, 61); 
    pixels.show(); // 네오픽셀 초기화
      }
      }

else if(bs1 && br1){
     noteOff(0, bn1, 0);   
     bs1 = false;
      pixels.clear(); 
      pixels.show();
       }
   
 if( !bs2 && !br2 ){
     noteOn(0, bn2,100);
     bs2 = true;
    for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 204, 114, 61); 
    pixels.show();
      }
      }

else if(bs2 && br2){
     noteOff(0, bn2,0);   
     bs2 = false;
     pixels.clear(); 
     pixels.show();
   }   

 if( !bs3 && !br3 ){
     noteOn(0, bn3,100);
     bs3 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 171, 242, 0); 
     pixels.show();
     }
     }

else if(bs3 && br3){
     noteOff(0, bn3,0);   
     bs3 = false;
     pixels.clear(); 
     pixels.show();
   }

 if( !bs4 && !br4 ){
     noteOn(0, bn4,100);
     bs4 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 29, 219, 22); 
     pixels.show();
     }
     }

  else if(bs4 && br4){
     noteOff(0, bn4,0);   
     bs4 = false;
     pixels.clear(); 
     pixels.show();
   }

if( !bs5 && !br5 ){
    noteOn(0, bn5,100);
    bs5 = true;
    for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 0, 216, 255); 
    pixels.show();
     }
     }

else if(bs5 && br5){
     noteOff(0, bn5,0);   
     bs5 = false;
     pixels.clear(); 
     pixels.show();
   }   

if( !bs6 && !br6 ){
   noteOn(0, bn6,100);
   bs6 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 0, 84, 255); 
    pixels.show();
     }     }
else if(bs6 && br6){
     noteOff(0, bn6,0);   
     bs6 = false;
     pixels.clear(); 
     pixels.show();
   }   
   
if( !bs7 && !br7 ){
   noteOn(0, bn7,100);
   bs7 = true;
   for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 0, 0, 255); 
    pixels.show();
   }
   }

else if(bs7 && br7){
     noteOff(0, bn7,0);   
     bs7 = false;
     pixels.clear(); 
    pixels.show();
    }   

if( !bs8 && !br8 ){
   noteOn(0, bn8,100);
   bs8 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 95, 0, 255); 
   pixels.show();
    }
    }

else if(bs8 && br8){
     noteOff(0, bn8,0);   
     bs8 = false;
     pixels.clear(); 
     pixels.show();
   }   
   } 
if (br14 == HIGH) { //A1 버튼 누르지 않으면,  
   pixels.clear(); 
   pixels.show();
   noteOff(0, 0,0);

   } else {//A1 버튼을 눌렀다면 // #define btn14 A1//  2옥타브 버튼

if( !bs1 && !br1 ){
     noteOn(0, bn11,100);
     bs1 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 204, 61, 61); 
     pixels.show();
      }
      }

else if(bs1 && br1){
     noteOff(0, bn11,0);   
     bs1 = false;
     pixels.clear(); 
     pixels.show();
      }

if( !bs2 && !br2 ){
   noteOn(0, bn12,100);
   bs2 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 204, 114, 61); 
   pixels.show();
    }
    }

else if(bs2 && br2){
     noteOff(0, bn12,0);   
     bs2 = false;
     pixels.clear(); 
     pixels.show();
   }   

if( !bs3 && !br3 ){
   noteOn(0, bn13,100);
     bs3 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 171, 242, 0); 
     pixels.show();
     }
     }

else if(bs3 && br3){
     noteOff(0, bn13,0);   
     bs3 = false;
     pixels.clear(); 
     pixels.show();
   }

if( !bs4 && !br4 ){
   noteOn(0, bn14,100);
   bs4 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 29, 219, 22); 
   pixels.show();
     }
     }

else if(bs4 && br4){
     noteOff(0, bn14,0);   
     bs4 = false;
     pixels.clear(); 
      pixels.show();
   }

if( !bs5 && !br5 ){
   noteOn(0, bn15,100);
   bs5 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 0, 216, 255); 
   pixels.show();
   }
   }

else if(bs5 && br5){
     noteOff(0, bn15,0);   
     bs5 = false;
     pixels.clear(); 
     pixels.show();
     }   
  
if( !bs6 && !br6 ){
   noteOn(0, bn16,100);
   bs6 = true;
   for(int i=0; i<4; i++){
  pixels.setPixelColor(i, 0, 84, 255); 
  pixels.show();
   }
   }

else if(bs6 && br6){
     noteOff(0, bn16,0);   
     bs6 = false;
     pixels.clear(); 
     pixels.show();
   }   
   
 if( !bs7 && !br7 ){
   noteOn(0, bn17,100);
   bs7 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 0, 0, 255); 
   pixels.show();
   }
   }

 else if(bs7 && br7){
     noteOff(0, bn17,0);   
     bs7 = false;
     pixels.clear(); 
     pixels.show();
    }   

 if( !bs8 && !br8 ){
     noteOn(0, bn18,100);
     bs8 = true;
     for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 95, 0, 255); 
    pixels.show();
     }
     }

else if(bs8 && br8){
     noteOff(0, bn18,0);   
     bs8 = false;
     pixels.clear(); 
     pixels.show();
   }   
   }


if (br15 == HIGH) {//1번핀 버튼 누르지 않으면 

  pixels.clear(); 
  pixels.show();
  noteOff(0, 0,0);
   } 
else {
    //1 버튼을 눌렀다면// br15 = digitalRead(btn15);// #define btn15 1//3옥타브 버튼  

if( !bs1 && !br1 ){
     noteOn(0, bn21,100);
     bs1 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 204, 61, 61); 
     pixels.show();
      }
      }

else if(bs1 && br1){
     noteOff(0, bn21,0);   
     bs1 = false;
     pixels.clear(); 
     pixels.show();
    }

if( !bs2 && !br2 ){
   noteOn(0, bn22,100);
     bs2 = true;
    for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 204, 114, 61); 
    pixels.show();
    }
    }

else if(bs2 && br2){
     noteOff(0, bn22,0);   
     bs2 = false;
     pixels.clear(); 
     pixels.show();
   }   

if( !bs3 && !br3 ){
   noteOn(0, bn23,100);
   bs3 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 171, 242, 0); 
   pixels.show();
    }
    }

else if(bs3 && br3){
     noteOff(0, bn23,0);   
     bs3 = false;
     pixels.clear(); 
     pixels.show();
     }

   if( !bs4 && !br4 ){
     noteOn(0, bn24,100);
     bs4 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 29, 219, 22); 
     pixels.show();
     }
     }

else if(bs4 && br4){
     noteOff(0, bn24,0);   
     bs4 = false;
     pixels.clear(); 
     pixels.show();
   }

   if( !bs5 && !br5 ){
     noteOn(0, bn25,100);
     bs5 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 0, 216, 255); 
     pixels.show();
     }
     }

else if(bs5 && br5){
     noteOff(0, bn25,0);   
     bs5 = false;
     pixels.clear(); 
     pixels.show();
   }   

   if( !bs6 && !br6 ){
     noteOn(0, bn26,100);
     bs6 = true;
     for(int i=0; i<4; i++){
     pixels.setPixelColor(i, 0, 84, 255); 
     pixels.show();
     }
     }

else if(bs6 && br6){
     noteOff(0, bn26,0);   
     bs6 = false;
     pixels.clear(); 
     pixels.show();
   }   
   
   if( !bs7 && !br7 ){
     noteOn(0, bn27,100);
     bs7 = true;
     for(int i=0; i<4; i++){
    pixels.setPixelColor(i, 0, 0, 255); 
    pixels.show();
    }
    }

else if(bs7 && br7){
     noteOff(0, bn27,0);   
     bs7 = false;
     pixels.clear(); 
     pixels.show();
   }   

if( !bs8 && !br8 ){
   noteOn(0, bn28,100);
   bs8 = true;
   for(int i=0; i<4; i++){
   pixels.setPixelColor(i, 95, 0, 255); 
   pixels.show();
   }
   }

else if(bs8 && br8){
     noteOff(0, bn28,0);   
     bs8 = false;
     pixels.clear(); 
     pixels.show();
   }   
   }

 
if( !bs9 && !br9 ){ //patch up (max:127)
   patch++;
   if(patch >127) patch = 0;
   talkMIDI(0xc0, patch, 0);     
   bs9 = true;
   }
else if(bs9 && br9){
     bs9 = false;
   }   

if( !bs10 && !br10 ){ //patch down (min:0)
   patch--;
   if(patch < 0) patch = 127;
   talkMIDI(0xc0, patch, 0);       
   bs10 = true;
   }

 else if(bs10 && br10){
     bs10 = false;
   }   
   
if( !bs11 && !br11 ){ //bank 0x78(drum)
   talkMIDI(0xb0, 0, 0x78);
   talkMIDI(0xb0,20, 0);
   talkMIDI(0xc0, patch, 0);     
   bs11 = true;
   }

else if(bs11 && br11){
     bs11 = false;
   }   
   
if( !bs12 && !br12 ){ //bank MSB 0, default instruments
     patch = defaultPatch;
     talkMIDI(0xb0, 0, 0);
     talkMIDI(0xb0,20, 0);
     talkMIDI(0xc0, patch, 0);       
     bs12 = true;
      }
else if(bs12 && br12){
     bs12 = false;   }   
 
  
  //*************** MIDI LOOPBACK ******************//
  if(Serial.available() > 0)
  {
    byteData =  Serial.read();
    mySerial.write( byteData);
  }  
  }

//노트 온 미디 메세지를 송출합니다. 버튼이 눌린상태와 같습니다.
//채널 범위는 0-15입니다.
  void noteOn(byte channel, byte note, byte attack_velocity) {
  talkMIDI( (0x90 | channel), note, attack_velocity);
}

//노트 오프 미디 메세지를 송출합니다. 버튼이 눌리지 않은 상태와 같습니다.
void noteOff(byte channel, byte note, byte release_velocity) {
  talkMIDI( (0x80 | channel), note, release_velocity);
}


void talkMIDI(byte cmd, byte data1, byte data2) {
  digitalWrite(ledPin, HIGH);
  mySerial.write(cmd );
  mySerial.write(data1 );

  //모든 명령은 1바이트를 지니며, 모든 cmds는 0xBn보다 2 데이터 바이트를 덜 지닙니다.  
  //(sort of: http://253.ccarh.org/handout/midiprotocol/)

  if( (cmd & 0xF0) <= 0xB0)
  mySerial.write(data2 );
  digitalWrite(ledPin, LOW);
  }
